local g = vim.g
local icons = require('cosmic.core.theme.icons')
local M = {}

function M.init()
  -- settings
  g.nvim_tree_git_hl = 1
  g.nvim_tree_refresh_wait = 300

  g.nvim_tree_special_files = {}
  g.nvim_tree_show_icons = {
    git = 1,
    folders = 1,
    files = 1,
    folder_arrows = 1,
  }

  g.nvim_tree_icons = {
    default = '',
    symlink = icons.symlink,
    git = icons.git,
    folder = icons.folder,

    lsp = {
      hint = icons.hint,
      info = icons.info,
      warning = icons.warn,
      error = icons.error,
    },
  }

  -- set up args
  local args = {
    auto_close = true,
    diagnostics = {
      enable = true,
    },
    update_focused_file = {
      enable = true,
      ignore_list = {},
    },
  }

  require('nvim-tree').setup(args)
end

return M
